----------------------------------------------------------------------------
-- @Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------
CrowsSoundFix = {};

CrowsSoundFix.volumes = {};
CrowsSoundFix.volumes.flyAway = {};
CrowsSoundFix.volumes.flyAway.outdoorVolume = 0.4;
CrowsSoundFix.volumes.flyAway.indoorVolume = CrowsSoundFix.volumes.flyAway.outdoorVolume*0.7;
CrowsSoundFix.volumes.calmGround = {};
CrowsSoundFix.volumes.calmGround.outdoorVolume = 0.15;
CrowsSoundFix.volumes.calmGround.indoorVolume = CrowsSoundFix.volumes.calmGround.outdoorVolume*0.7;
CrowsSoundFix.volumes.busy = {};
CrowsSoundFix.volumes.busy.outdoorVolume = 0.25;
CrowsSoundFix.volumes.busy.indoorVolume = CrowsSoundFix.volumes.busy.outdoorVolume*0.7;
CrowsSoundFix.volumes.calmAir = {};
CrowsSoundFix.volumes.calmAir.outdoorVolume = 0.25;
CrowsSoundFix.volumes.calmAir.indoorVolume = CrowsSoundFix.volumes.calmAir.outdoorVolume*0.7;
--CrowsSoundFix.volumes.innerRange = 1.0; --(default 1.0);
CrowsSoundFix.volumes.outerRange = 60.0; --(default 60.0);
----

--function CrowsSoundFix:load(xmlFilename)
CrowsWildlife.load = function (self, xmlFilename)
    CrowsWildlife:superClass().load(self, xmlFilename);
    local xmlFile = loadXMLFile("TempXML", self.xmlFilename);
    if xmlFile == 0 then
        self.xmlFilename = nil;
        return false;
    end;
    self.samples = {};
    self.samples.flyAway = {};
    local i = 0;
    while true do
        local sampleFlyAway = g_soundManager:loadSampleFromXML(xmlFile, "wildlifeAnimal.sounds.flyAways", string.format("flyAway(%d)", i), self.baseDirectory, self.soundsNode, 1, AudioGroup.ENVIRONMENT, nil, nil)
        if sampleFlyAway == nil then
            break;
        end;
        table.insert(self.samples.flyAway, sampleFlyAway);
        i = i + 1;
    end;
    self.samples.flyAwayCount = i;
    self.samples.calmGround = {};
    local j = 0;
    while true do
        local sampleCalmGround = g_soundManager:loadSampleFromXML(xmlFile, "wildlifeAnimal.sounds.calmGrounds", string.format("calmGround(%d)", j), self.baseDirectory, self.soundsNode, 1, AudioGroup.ENVIRONMENT, nil, nil);
        if sampleCalmGround == nil then
            break;
        end;
        table.insert(self.samples.calmGround, sampleCalmGround);
        j = j + 1;
    end;
    self.samples.calmCount = j;
    self.samples.busy = g_soundManager:loadSampleFromXML(xmlFile, "wildlifeAnimal.sounds", "busy", self.baseDirectory, self.soundsNode, 0, AudioGroup.ENVIRONMENT, nil, nil);
    self.samples.calmAir = g_soundManager:loadSampleFromXML(xmlFile, "wildlifeAnimal.sounds", "calmAir", self.baseDirectory, self.soundsNode, 0, AudioGroup.ENVIRONMENT, nil, nil);
	----
	self.crowsSoundFix = {};
	self.crowsSoundFix.samples = {};
	self.crowsSoundFix.samples.flyAway = {};
	self.crowsSoundFix.samples.calmGround = {};
	self.crowsSoundFix.samples.busy = {};
	self.crowsSoundFix.samples.calmAir = {};
	for _, samples in pairs(self.samples.flyAway) do
		--print("Filename: "..samples.filename);
		--print("Duration: "..samples.duration);
		table.insert(self.crowsSoundFix.samples.flyAway, createSample("flyAway"..#self.crowsSoundFix.samples.flyAway+1));
		loadSample(self.crowsSoundFix.samples.flyAway[#self.crowsSoundFix.samples.flyAway], samples.filename, false);
	end;

	for _, samples in pairs(self.samples.calmGround) do
		--print("Filename: "..samples.filename);
		--print("Duration: "..samples.duration);
		table.insert(self.crowsSoundFix.samples.calmGround, createSample("flyAway"..#self.crowsSoundFix.samples.calmGround+1));
		loadSample(self.crowsSoundFix.samples.calmGround[#self.crowsSoundFix.samples.calmGround], samples.filename, false);
	end;
	self.crowsSoundFix.samples.busy.sound = createSample("busy");
	loadSample(self.crowsSoundFix.samples.busy.sound, self.samples.busy.filename, false);
	--print("Filename: "..self.samples.busy.filename);
	--print("Duration: "..self.samples.busy.duration);
	self.crowsSoundFix.samples.calmAir.sound = createSample("calmAir");
	loadSample(self.crowsSoundFix.samples.calmAir.sound, self.samples.calmAir.filename, false);
	--print("Filename: "..self.samples.calmAir.filename);
	--print("Duration: "..self.samples.calmAir.duration);

	self.updateCrowsSoundVolume = CrowsWildlife.updateCrowsSoundVolume;
	self.stopAllSounds = CrowsWildlife.stopAllSounds;
	self.checkIndividualCrows = CrowsWildlife.checkIndividualCrows;
	
	--[[ Table Entries per Sound Table
	samples.filename
	samples.sampleName
	samples.soundSample
	samples.audioGroup
	samples.loops
	samples.duration
	samples.outdoorAttributes (.volume .pitch .lowpassGain)
	samples.indoorAttributes (.volume .pitch .lowpassGain)
	samples.innerRange
	samples.innerRadius
	samples.outerRange
	samples.outerRadius
	samples.soundNode
	samples.linkNode
	samples.fade
	samples.fadeIn
	samples.fadeOut
	samples.sourceRandomizations
	samples.randomizationsIn
	samples.randomizationsOut
	samples.isDirty
	samples.current
	samples.modifiers
	]]
	print("Load mod: Crow Sounds Fix, by ViperGTS96");
----
    delete(xmlFile);
    return true;
end;

--CrowsSoundFix.load = Utils.overwrittenFunction(CrowsWildlife.load, CrowsSoundFix.load);

function CrowsWildlife:stopAllSounds(samples)
	for i=1, #samples.flyAway do		
		if isSamplePlaying(samples.flyAway[i]) then
			stopSample(samples.flyAway[i], 0, 0);
		end;
	end;
	for i=1, #samples.calmGround do
		if isSamplePlaying(samples.calmGround[i]) then
			stopSample(samples.calmGround[i], 0, 0);
		end;
	end;
	if isSamplePlaying(samples.busy.sound) then
		stopSample(samples.busy.sound, 0, 0);
	end;
	if isSamplePlaying(samples.calmAir.sound) then
		stopSample(samples.calmAir.sound, 0, 0);
	end;
end;

function CrowsWildlife:updateCrowsSoundVolume(indexFlight, indexGround)
	local player = g_currentMission.player;
	local vehicle = g_currentMission.controlledVehicle;
	local volumes = CrowsSoundFix.volumes;
	local isInside = false;
	local distance = 0;
	local pX,pY,pZ = 0,0,0;
	local soundIndex = self.soundFSM.currentState.playingSound;

	if player == nil and vehicle == nil then
		return;
	elseif vehicle ~= nil then 
		local camera = vehicle.spec_enterable;
		if camera ~= nil then camera = camera.spec_enterable.activeCamera; end;
		if camera ~= nil then
			if camera.isInside then			
				isInside = true; --print("inside");
			end;
			pX,pY,pZ = getWorldTranslation(vehicle.rootNode);
		end;
	elseif player ~= nil then 
		pX,pY,pZ = getWorldTranslation(player.rootNode);		
	end;	

	--local flockOfCrows = self.samples.flyAway[1].soundNode;
	local flockOfCrows = self.samples.flyAway[indexFlight].soundNode;
	if soundIndex == 2 then
		flockOfCrows = self.samples.calmGround[indexGround].soundNode;
	elseif soundIndex == 3 then
		flockOfCrows = self.samples.busy.soundNode;
	elseif soundIndex == 4 then
		flockOfCrows = self.samples.calmAir.soundNode;
	end;
	local cX,cY,cZ = getWorldTranslation(flockOfCrows);
	--local cX,cY,cZ = getWorldTranslation(self.animals[i=closest].i3dNodeId);

	distance = pX-cX; if pX<cX then distance = cX-pX; end;
	local distance2 = pY-cY; if pY<cY then distance2 = cY-pY; end;
	local distance3 = pZ-cZ; if pZ<cZ then distance3 = cZ-pZ; end;
	distance = distance+distance2+distance3;

	if distance <= 0 or distance > volumes.outerRange then		
		self:stopAllSounds(self.crowsSoundFix.samples);
		self.soundFSM.currentState.playingSound = 0;
		return;
	end;

	--if soundIndex == 1 then
		for i=1, #self.crowsSoundFix.samples.flyAway do
			local sound = self.crowsSoundFix.samples.flyAway[i];
			if isSamplePlaying(sound) then
				local volume = volumes.flyAway.outdoorVolume; if isInside then volume = volumes.flyAway.indoorVolume; end;
				volume = MathUtil.clamp(volume - (distance/volumes.outerRange),0,1);
				if volume <= 0 then 
					stopSample(sound, 0, 0);
					self.soundFSM.currentState.playingSound = 0;
				else
					setSampleVolume(sound, volume);	--print("flyAway: "..tostring(volume));
				end;
			end;
		end; 
	--end;
	--if soundIndex == 2 then
		for i=1, #self.crowsSoundFix.samples.calmGround do
			local sound = self.crowsSoundFix.samples.calmGround[i];
			if isSamplePlaying(sound) then
				local volume = volumes.calmGround.outdoorVolume; if isInside then volume = volumes.calmGround.indoorVolume; end;
				volume = MathUtil.clamp(volume - (distance/volumes.outerRange),0,1);
				if volume <= 0 then 
					stopSample(sound, 0, 0);
					self.soundFSM.currentState.playingSound = 0;
				else
					setSampleVolume(sound, volume);	--print("calmGround: "..tostring(volume));
				end;
			end;
		end; 
	--end;
	--if soundIndex == 3 then 
	local sound = self.crowsSoundFix.samples.busy.sound;
		if isSamplePlaying(sound) then
			local volume = volumes.busy.outdoorVolume; if isInside then volume = volumes.busy.indoorVolume; end;
			volume = MathUtil.clamp(volume - (distance/volumes.outerRange),0,1);
			if volume <= 0 then 
				stopSample(sound, 0, 0);
				self.soundFSM.currentState.playingSound = 0;
			else
				setSampleVolume(sound, volume);	--print("busy: "..tostring(volume));
			end;
		end;
	--end; 
	--if soundIndex == 4 then
		sound = self.crowsSoundFix.samples.calmAir.sound;
		if isSamplePlaying(sound) then
			local volume = volumes.calmAir.outdoorVolume; if isInside then volume = volumes.calmAir.indoorVolume; end;
			volume = MathUtil.clamp(volume - (distance/volumes.outerRange),0,1);
			if volume <= 0 then 
				stopSample(sound, 0, 0);
				self.soundFSM.currentState.playingSound = 0;
			else
				setSampleVolume(sound, volume);	--print("calmAir: "..tostring(volume));
			end;
		end;
	--end;
	--print(tostring(distance)); --renderText(0.5,0.05,0.02,tostring(distance));
end;

function CrowsWildlife:checkIndividualCrows()
	for _, animal in pairs(self.animals) do
		--Possible States: "idle_walk","idle_eat","idle_attention","fly","fly_guide","takeOff"
		if animal.stateMachine.currentState.id == "takeOff" and self.soundFSM.currentState.id ~= CrowsWildlife.CROW_SOUND_STATES.TAKEOFF and self.soundFSM.currentState.playingSound ~= 1 then
			for i=1, #self.crowsSoundFix.samples.flyAway do if isSamplePlaying(self.crowsSoundFix.samples.flyAway[i]) then return; end; end;
			local volume = CrowsSoundFix.volumes.flyAway.outdoorVolume;
			local flyAwayIndex = math.floor(math.random(1,#self.crowsSoundFix.samples.flyAway));
			playSample(self.crowsSoundFix.samples.flyAway[flyAwayIndex],1,volume, 0, 0, 0);
			self.soundFSM.currentState.playingSound = 1;
		end;
	end;
end;

CrowsWildlife.update = function (self, dt)
    CrowsWildlife:superClass().update(self, dt);
    if #self.animals > 0 then
        self.soundFSM:update(dt); --Old Function to update "simple state machine" values
		if g_gui:getIsGuiVisible() then return end;
		local flyAwayIndex = 0;
		local calmGroundIndex = 1;
		local baseVolume = 0.1;
		if self.soundFSM.currentState.id == CrowsWildlife.CROW_SOUND_STATES.TAKEOFF and self.soundFSM.currentState.playingSound ~= 1 then --print("TAKEOFF");
			self.soundFSM.currentState.playingSound = 1;
			for i=1, #self.crowsSoundFix.samples.flyAway do if isSamplePlaying(self.crowsSoundFix.samples.flyAway[i]) then return; end; end;
			flyAwayIndex = math.floor(math.random(1,#self.crowsSoundFix.samples.flyAway));
			playSample(self.crowsSoundFix.samples.flyAway[flyAwayIndex],1,baseVolume, 0, 0, 0);
		elseif self.soundFSM.currentState.id == CrowsWildlife.CROW_SOUND_STATES.CALM_GROUND and self.soundFSM.currentState.playingSound ~= 2 then --print("CALM_GROUND");
			self.soundFSM.currentState.playingSound = 2;
			for i=1, #self.crowsSoundFix.samples.calmGround do if isSamplePlaying(self.crowsSoundFix.samples.calmGround[i]) then return; end; end;
			calmGroundIndex = math.floor(math.random(1,#self.crowsSoundFix.samples.calmGround));
			playSample(self.crowsSoundFix.samples.calmGround[calmGroundIndex],1,baseVolume, 0, 0, 0);
		elseif self.soundFSM.currentState.id == CrowsWildlife.CROW_SOUND_STATES.BUSY and self.soundFSM.currentState.playingSound ~= 3 then	--print("BUSY");
			self.soundFSM.currentState.playingSound = 3;
			if not isSamplePlaying(self.crowsSoundFix.samples.busy.sound) then
			playSample(self.crowsSoundFix.samples.busy.sound,1,baseVolume, 0, 0, 0); end;--Looping Sound?
		elseif self.soundFSM.currentState.id == CrowsWildlife.CROW_SOUND_STATES.CALM_AIR and self.soundFSM.currentState.playingSound ~= 4 then --print("CALM_AIR");
			self.soundFSM.currentState.playingSound = 4;
			if not isSamplePlaying(self.crowsSoundFix.samples.calmAir.sound) then
			playSample(self.crowsSoundFix.samples.calmAir.sound,1,baseVolume, 0, 0, 0); end;--Looping Sound?
		elseif self.soundFSM.currentState.playingSound ~= 0 then
			self.soundFSM.currentState.playingSound = 0;
		end;
		if flyAwayIndex == 0 then flyAwayIndex = 1; self:checkIndividualCrows(); end;
        self:updateCrowsSoundVolume(flyAwayIndex, calmGroundIndex); --New Function to set sound volumes based on distance
    elseif self.soundFSM.currentState.id ~= CrowsWildlife.CROW_SOUND_STATES.NONE then
        self.soundFSM:changeState(CrowsWildlife.CROW_SOUND_STATES.NONE);
		if self.soundFSM.currentState.playingSound ~= 0 then self:stopAllSounds(self.crowsSoundFix.samples) end;
		self.soundFSM.currentState.playingSound = 0;
    end;
end;